install.sh 7.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246
  1. #!/bin/sh
  2. # This script installs Ollama on Linux.
  3. # It detects the current operating system architecture and installs the appropriate version of Ollama.
  4. set -eu
  5. status() { echo ">>> $*" >&2; }
  6. error() { echo "ERROR $*"; exit 1; }
  7. warning() { echo "WARNING: $*"; }
  8. TEMP_DIR=$(mktemp -d)
  9. cleanup() { rm -rf $TEMP_DIR; }
  10. trap cleanup EXIT
  11. available() { command -v $1 >/dev/null; }
  12. require() {
  13. local MISSING=''
  14. for TOOL in $*; do
  15. if ! available $TOOL; then
  16. MISSING="$MISSING $TOOL"
  17. fi
  18. done
  19. echo $MISSING
  20. }
  21. [ "$(uname -s)" = "Linux" ] || error 'This script is intended to run on Linux only.'
  22. ARCH=$(uname -m)
  23. case "$ARCH" in
  24. x86_64) ARCH="amd64" ;;
  25. aarch64|arm64) ARCH="arm64" ;;
  26. *) error "Unsupported architecture: $ARCH" ;;
  27. esac
  28. SUDO=
  29. if [ "$(id -u)" -ne 0 ]; then
  30. # Running as root, no need for sudo
  31. if ! available sudo; then
  32. error "This script requires superuser permissions. Please re-run as root."
  33. fi
  34. SUDO="sudo"
  35. fi
  36. NEEDS=$(require curl awk grep sed tee xargs)
  37. if [ -n "$NEEDS" ]; then
  38. status "ERROR: The following tools are required but missing:"
  39. for NEED in $NEEDS; do
  40. echo " - $NEED"
  41. done
  42. exit 1
  43. fi
  44. status "Downloading ollama..."
  45. curl --fail --show-error --location --progress-bar -o $TEMP_DIR/ollama "https://ollama.ai/download/ollama-linux-$ARCH"
  46. for BINDIR in /usr/local/bin /usr/bin /bin; do
  47. echo $PATH | grep -q $BINDIR && break || continue
  48. done
  49. status "Installing ollama to $BINDIR..."
  50. $SUDO install -o0 -g0 -m755 -d $BINDIR
  51. $SUDO install -o0 -g0 -m755 $TEMP_DIR/ollama $BINDIR/ollama
  52. install_success() { status 'Install complete. Run "ollama" from the command line.'; }
  53. trap install_success EXIT
  54. # Everything from this point onwards is optional.
  55. configure_systemd() {
  56. if ! id ollama >/dev/null 2>&1; then
  57. status "Creating ollama user..."
  58. $SUDO useradd -r -s /bin/false -m -d /usr/share/ollama ollama
  59. fi
  60. status "Adding current user to ollama group..."
  61. $SUDO usermod -a -G ollama $(whoami)
  62. status "Creating ollama systemd service..."
  63. cat <<EOF | $SUDO tee /etc/systemd/system/ollama.service >/dev/null
  64. [Unit]
  65. Description=Ollama Service
  66. After=network-online.target
  67. [Service]
  68. ExecStart=$BINDIR/ollama serve
  69. User=ollama
  70. Group=ollama
  71. Restart=always
  72. RestartSec=3
  73. Environment="PATH=$PATH"
  74. [Install]
  75. WantedBy=default.target
  76. EOF
  77. SYSTEMCTL_RUNNING="$(systemctl is-system-running || true)"
  78. case $SYSTEMCTL_RUNNING in
  79. running|degraded)
  80. status "Enabling and starting ollama service..."
  81. $SUDO systemctl daemon-reload
  82. $SUDO systemctl enable ollama
  83. start_service() { $SUDO systemctl restart ollama; }
  84. trap start_service EXIT
  85. ;;
  86. esac
  87. }
  88. if available systemctl; then
  89. configure_systemd
  90. fi
  91. if ! available lspci && ! available lshw; then
  92. warning "Unable to detect NVIDIA GPU. Install lspci or lshw to automatically detect and install NVIDIA CUDA drivers."
  93. exit 0
  94. fi
  95. check_gpu() {
  96. case $1 in
  97. lspci) available lspci && lspci -d '10de:' | grep -q 'NVIDIA' || return 1 ;;
  98. lshw) available lshw && $SUDO lshw -c display -numeric | grep -q 'vendor: .* \[10DE\]' || return 1 ;;
  99. nvidia-smi) available nvidia-smi || return 1 ;;
  100. esac
  101. }
  102. if check_gpu nvidia-smi; then
  103. status "NVIDIA GPU installed."
  104. exit 0
  105. fi
  106. if ! check_gpu lspci && ! check_gpu lshw; then
  107. warning "No NVIDIA GPU detected. Ollama will run in CPU-only mode."
  108. exit 0
  109. fi
  110. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-7-centos-7
  111. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-8-rocky-8
  112. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-9-rocky-9
  113. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#fedora
  114. install_cuda_driver_yum() {
  115. status 'Installing NVIDIA repository...'
  116. case $PACKAGE_MANAGER in
  117. yum)
  118. $SUDO $PACKAGE_MANAGER -y install yum-utils
  119. $SUDO $PACKAGE_MANAGER-config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-$1$2.repo
  120. ;;
  121. dnf)
  122. $SUDO $PACKAGE_MANAGER config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-$1$2.repo
  123. ;;
  124. esac
  125. case $1 in
  126. rhel)
  127. status 'Installing EPEL repository...'
  128. # EPEL is required for third-party dependencies such as dkms and libvdpau
  129. $SUDO $PACKAGE_MANAGER -y install https://dl.fedoraproject.org/pub/epel/epel-release-latest-$2.noarch.rpm || true
  130. ;;
  131. esac
  132. status 'Installing CUDA driver...'
  133. if [ "$1" = 'centos' ] || [ "$1$2" = 'rhel7' ]; then
  134. $SUDO $PACKAGE_MANAGER -y install nvidia-driver-latest-dkms
  135. fi
  136. $SUDO $PACKAGE_MANAGER -y install cuda-drivers
  137. }
  138. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#ubuntu
  139. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#debian
  140. install_cuda_driver_apt() {
  141. status 'Installing NVIDIA repository...'
  142. curl -fsSL -o $TEMP_DIR/cuda-keyring.deb https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-keyring_1.1-1_all.deb
  143. case $1 in
  144. debian)
  145. status 'Enabling contrib sources...'
  146. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list | sudo tee /etc/apt/sources.list.d/contrib.list > /dev/null
  147. ;;
  148. esac
  149. status 'Installing CUDA driver...'
  150. $SUDO dpkg -i $TEMP_DIR/cuda-keyring.deb
  151. $SUDO apt-get update
  152. [ -n "$SUDO" ] && SUDO_E="$SUDO -E" || SUDO_E=
  153. DEBIAN_FRONTEND=noninteractive $SUDO_E apt-get -y install cuda-drivers -q
  154. }
  155. if [ ! -f "/etc/os-release" ]; then
  156. error "Unknown distribution. Skipping CUDA installation."
  157. fi
  158. . /etc/os-release
  159. OS_NAME=$ID
  160. OS_VERSION=$VERSION_ID
  161. PACKAGE_MANAGER=
  162. for PACKAGE_MANAGER in dnf yum apt-get; do
  163. if available $PACKAGE_MANAGER; then
  164. break
  165. fi
  166. done
  167. if [ -z "$PACKAGE_MANAGER" ]; then
  168. error "Unknown package manager. Skipping CUDA installation."
  169. fi
  170. if ! check_gpu nvidia-smi || [ -z "$(nvidia-smi | grep -o "CUDA Version: [0-9]*\.[0-9]*")" ]; then
  171. case $OS_NAME in
  172. centos|rhel) install_cuda_driver_yum 'rhel' $OS_VERSION ;;
  173. rocky) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -c1) ;;
  174. fedora) install_cuda_driver_yum $OS_NAME $OS_VERSION ;;
  175. amzn) install_cuda_driver_yum 'fedora' '35' ;;
  176. debian) install_cuda_driver_apt $OS_NAME $OS_VERSION ;;
  177. ubuntu) install_cuda_driver_apt $OS_NAME $(echo $OS_VERSION | sed 's/\.//') ;;
  178. *) exit ;;
  179. esac
  180. fi
  181. if ! lsmod | grep -q nvidia; then
  182. KERNEL_RELEASE="$(uname -r)"
  183. case $OS_NAME in
  184. centos|rhel|rocky|amzn) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE kernel-headers-$KERNEL_RELEASE ;;
  185. fedora) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE ;;
  186. debian|ubuntu) $SUDO apt-get -y install linux-headers-$KERNEL_RELEASE ;;
  187. *) exit ;;
  188. esac
  189. NVIDIA_CUDA_VERSION=$($SUDO dkms status | awk -F: '/added/ { print $1 }')
  190. if [ -n "$NVIDIA_CUDA_VERSION" ]; then
  191. $SUDO dkms install $NVIDIA_CUDA_VERSION
  192. fi
  193. if lsmod | grep -q nouveau; then
  194. status 'Reboot to complete NVIDIA CUDA driver install.'
  195. exit 0
  196. fi
  197. $SUDO modprobe nvidia
  198. fi
  199. status "NVIDIA CUDA drivers installed."